<template>
  <nav aria-label="Search results pagination">
    <ul class="pagination justify-content-center">
      <li class="page-item">
        <a
          class="page-link"
          :class="{disabled: isInFirstPage}"
          href="#"
          @click="onClickFirstPage"
          aria-label="Go to first page"
        >
          First
        </a>
      </li>

      <li class="page-item">
        <a
          class="page-link"
          :class="{disabled: isInFirstPage}"
          href="#"
          @click="onClickPreviousPage"
          aria-label="Go to previous page"
        >
          Previous
        </a>
      </li>

      <li v-for="page in pages" class="page-item">
        <a
          class="page-link"
          :class="{active: isPageActive(page.name)}"
          href="#"
          @click="onClickPage(page.name)"
          :aria-label="`Go to page number ${page.name}`"
        >
          {{ page.name }}
        </a>
      </li>

      <li class="page-item">
        <a
          class="page-link"
          :class="{disabled: isInLastPage}"
          href="#"
          @click="onClickNextPage"
          aria-label="Go to next page"
        >
          Next
        </a>
      </li>

      <li class="page-item">
        <a
          class="page-link"
          :class="{disabled: isInLastPage}"
          href="#"
          @click="onClickLastPage"
          aria-label="Go to last page"
        >
          Last
        </a>
      </li>
    </ul>
  </nav>
</template>

<script setup>
import { computed } from 'vue';

const emit = defineEmits(['pagechanged'])


const props = defineProps({
  modelValue: Number,
  maxVisibleButtons: {
    type: Number,
    required: false,
    default: 5
  },
  totalPages: {
    type: Number,
    required: true
  },
  total: {
    type: Number,
    required: true
  },
  perPage: {
    type: Number,
    required: true
  },
});

const startPage = computed(() => {
  if (props.modelValue === 1 || props.modelValue <= props.maxVisibleButtons) {
    return 1;
  }

  if(props.modelValue > props.maxVisibleButtons) {
    return props.modelValue - props.maxVisibleButtons + 1
  }
})


const endPage = computed(() => {
  return Math.min(startPage.value + props.maxVisibleButtons - 1, props.totalPages);
})

const pages = computed(() => {
  const range = [];

  for (let i = startPage.value; i <= endPage.value; i += 1) {
    range.push({
      name: i,
      isDisabled: i === props.modelValue
    });
  }
  return range;
})

const isInFirstPage = computed(() => {
  return props.modelValue === 1;
})

const isInLastPage = computed(() => {
  return props.modelValue === props.totalPages;
})

const onClickFirstPage = () => {
  emit('update:modelValue', 1);
}

const onClickPreviousPage = () => {
  emit('update:modelValue', props.modelValue - 1);
}
const onClickPage = (page) => {
  emit('update:modelValue', page);
}

const onClickNextPage = () => {
  emit('update:modelValue', props.modelValue + 1);
}

const onClickLastPage = () => {
  emit('update:modelValue', props.totalPages);
}

const isPageActive = (page) => {
  return props.modelValue === page;
}

</script>

<style scoped>

</style>
